//---------------------------------------------------------------------------
//
//   TransMorph
//
//          Copyright(C) 2013, Tark
//
//	[tRs[vOC
//	NFIuWFNgplŏɎw肷
//	@@ό`OIuWFNgAό`IuWFNgAό`Kp郂[tIuWFNgEEE
//	ʁFό`Kpe[tIuWFNǧɕό`KpIuWFNg}
//
//---------------------------------------------------------------------------

//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "MQPlugin.h"
#include "MQBasePlugin.h"
#if MQPLUGIN_VERSION >= 0x0400
#include "MQ3DLib.h"
#include "MQWidget.h"
#endif

#include "Diff.h"
#include <math.h>
#include <vector>
#include <unordered_map>
#include <set>
#include <memory>
#include <sstream>
#include <algorithm>

#include "TransMorph.h"
#include "resource.h"

#if MQPLUGIN_VERSION < 0x0400
HINSTANCE hInstance;
#endif

//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
#if MQPLUGIN_VERSION < 0x0400
	//_CAO{bNX̕\ɕKvȂ̂ŁACX^XۑĂ
	hInstance = (HINSTANCE)hModule;
#endif

	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
	return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
void TransMorph::GetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0xE3F7A830;
	*ID      = 0xBD9A1860;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
const char *TransMorph::GetPlugInName(void)
{
	// vOC
	return "TransMorph v.1.4 Copyright(C) 2013-2014, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
const char *TransMorph::EnumString(int index)
{
	switch(index){
	case 0: return "TransMorph";
	}
	return nullptr;
}

MQBasePlugin *GetPluginClass()
{
	static TransMorph plugin;
	return &plugin;
}

BOOL TransMorph::Execute(int index, MQDocument doc_)
{
	switch(index){
	case 0:
		{
			doc = doc_;
			return main();
		}
	}
	return FALSE;
}

// staticIuWFNg
cmq::CMQDocument *TransMorph::Point::pdoc;
cmq::CMQObject *TransMorph::Point::pobjsrc;
cmq::CMQObject *TransMorph::Point::pobjdst;
const float TransMorph::Point::delta = 0.001f; // ʒuƂ݂Ȃ
TransMorph::TransMorphSetting TransMorph::transMorphSetting; // _CAOݒl

/*
	C[`
*/
BOOL TransMorph::main()
{
	// IuWFNgplőIIuWFNg擾
	getSelectedObjectList();
	// objsrcɑ΂郂[tIuWFNg𒊏o
	getMorphObjects(true, true);
	// ݒ_CAO\
	callDialog();
	if(!transMorphSetting.going) {
		return TRUE;
	}
	// _CAÕ[tIuWFNgIʂvecobjmorph쐬
	createMorphlist();
	// f̃[tIuWFNg쐬
	addNewMorph();
	// ~[}bv쐬
	makeVertexmapMirror();
	// oĒ_Ή}bv쐬
	makeVertexmapWithDiffer();
	// [tf
	transMorph();
	// srcdst̖OύX
	changeSrcName();
	// obNAbv폜
	deleteBackupObj();

	if(findfaceerrorflag) {
		// ʓ]ʂŌȂʂ̂ŃRs[łȂbZ[W
		MESSAGEBOX_(L"Attributes of some faces were not copied.", L"TransMorph");
	}
	return TRUE;
}

/*
	IuWFNgplőIIuWFNg擾
*/
BOOL TransMorph::getSelectedObjectList()
{
	int selected_count = 0;
	for(int i = 0; i < doc.getObjectCount(); i++) {
		cmq::CMQObject obj = doc.getObject(i);
		if(!obj.isLive()) {continue;}
		if(obj.getSelected()) {
			if(selected_count == 0) {objsrc = obj;}
			else if(selected_count == 1) {objdst = obj;}
			else {break;}
			selected_count++;
		}
	}
	if(selected_count == 1) {
		// 1IĂꍇ́Asrc = destƂ
		objdst = objsrc;
	}
	else if(selected_count < 1) {
		return FALSE;
	}
	transMorphSetting.srcname = objsrc.getName();
	transMorphSetting.dstname = objdst.getName();
	return TRUE;
}

/*
	objsrcɑ΂郂[tIuWFNg𒊏oA_CAÕXgɏo߂morphlistɓ
*/
BOOL TransMorph::getMorphObjects(bool selectOnlyElem, bool selectSameSize)
{
	transMorphSetting.morphlist.clear();
	// srcIuWFNg̖O
	string name = getObjectMainName(objsrc.getName());
	int vcount = objsrc.getVertexCount();
	// [tIuWFNg
	for(int i = 0; i < doc.getObjectCount(); i++) {
		cmq::CMQObject obj = doc.getObject(i);
		if(!obj.isLive()) {continue;}
		if(obj == objsrc || obj == objdst) {continue;}
		if(selectSameSize && obj.getVertexCount() != vcount) {continue;}
		string morphname = obj.getName();
		if(!selectOnlyElem || isMorphObject(name, morphname)) {
			transMorphSetting.morphlist.push_back(make_pair(obj, obj.getLocking() == FALSE));
		}
	}
	if(transMorphSetting.morphlist.size() == 0) {
		return FALSE;
	}
	return TRUE;
}

/*
	orignameIuWFNg𔲂o"`:(*)-`"
*/
string TransMorph::getObjectMainName(const string &origname)
{
	string name(origname);
	string::size_type pos;
	if((pos = name.find(':')) != string::npos) {
		name = name.substr(pos + 1);
	}
	if((pos = name.find('-')) != string::npos && pos > 1) {
		name = name.substr(0, pos);
	}
	return name;
}

/*
	morphobjnameobjnameɑ΂郂[ť`"elem:*-(*)"ł邩ۂ
*/
bool TransMorph::isMorphObject(const string &objname, const string &morphobjname)
{
	if(morphobjname.substr(0, 5) != "elem:") {
		return false;
	}
	string::size_type pos;
	if((pos = morphobjname.find('-')) != string::npos) {
		if(objname == morphobjname.substr(pos + 1)) {
			return true;
		}
	}
	return false;
}

/*
	_CAÕ[tIuWFNgIʂvecobjmorph쐬
*/
void TransMorph::createMorphlist()
{
	for(std::pair<cmq::CMQObject, bool> &p : transMorphSetting.morphlist) {
		if(p.second) {
			vecobjmorph.push_back(p.first);
		}
	}
	transMorphSetting.morphlist.clear();
}

/*
	[tIuWFNgpobjdst̃N[쐬Ēǉ
*/
BOOL TransMorph::addNewMorph()
{
	// f惂[t쐬
	const int NAME_BUFFER_SIZE = 250;
	char newobjname[NAME_BUFFER_SIZE + 1] = "";
	for(cmq::CMQObject &obj : vecobjmorph) {
		//[tIuWFNg𕡐
		cmq::CMQObject newmorph =  objdst.clone();
		string objname = obj.getName();
		if(transMorphSetting.newname) {
			string::size_type pos;
			if((pos = objname.find('-')) == string::npos) {
				// IuWFNgGǧ`ł͂Ȃ
				pos = objname.length();
			}
			// ǉ[tIuWFNg̖OƂāA[ť"new"Ɛt̂t
			string morphname = objname.substr(0, pos);
			string srcobjname = objname.substr(pos);
			string newname;
			int no = 0;
			do {
				no++;
				ostringstream s;
				s << morphname << "new" << no << srcobjname;
				newname = s.str();
			}while(doc.getObjectbyName(newname).isLive());
			newmorph.setName(newname);
		}
		else {
			//̃[tobj͐擪#tOɂ(unused nameɂ)
			obj.setName(doc.getUnusedName("#" + objname).c_str());
			//ǉ[tobj̓Rs[̖Oɂ
			newmorph.setName(objname.c_str());
		}
		vecobjnewmorph.push_back(newmorph);
		doc.insertObject(newmorph, obj);
	}
	return TRUE;
}

/*
	~[_}bv쐬
*/
BOOL TransMorph::makeVertexmapMirror()
{
	if(!transMorphSetting.morph_mirroring) {
		// ~[gȂꍇ͍쐬Ȃ
		return FALSE;
	}
	const float delta = 0.001f; // WƂ݂Ȃ

	int vcount = objdst.getVertexCount();
	for(int i = 0; i < vcount; i++) {
		if(objdst.getVertexRefCount(i) == 0) {
			continue;
		}
		if(vecmirrormap.find(i) != vecmirrormap.end()) {
			// Ɍς
			continue;
		}
		MQPoint pi = objdst.getVertex(i);
		if(abs(pi.x) < delta) {
			// ΏۋEʏ
			vecmirrormap.insert(make_pair(i, i));
			continue;
		}
		pi.x = -pi.x;
		for(int j = 0; j < vcount; j++) {
			if(objdst.getVertexRefCount(j) == 0) {
				continue;
			}
			if(i == j) {
				continue;
			}
			MQPoint pj = objdst.getVertex(j);
			if((pi - pj).norm() < delta * delta) {
				// Ώے_
				vecmirrormap.insert(make_pair(j, i));
				vecmirrormap.insert(make_pair(i, j));
				break;
			}
		}
	}
	return TRUE;
}


/*
	oĒ_Ή}bv쐬
*/
BOOL TransMorph::makeVertexmapWithDiffer()
{
	if(transMorphSetting.use_unique_id) {
		// UIDgꍇ͍쐬Ȃ
		return FALSE;
	}
	Point::set(doc, objsrc, objdst);
	// o钸_Xg쐬
	std::vector<Point> srcvlist;
	srcvlist.reserve(objsrc.getVertexCount());
	for(int i = 0; i < objsrc.getVertexCount(); i++) {
		if(objsrc.getVertexRefCount(i) > 0) {
			srcvlist.push_back(Point(i, Point::SRC));
		}
	}
	std::vector<Point> dstvlist;
	dstvlist.reserve(objdst.getVertexCount());
	for(int i = 0; i < objdst.getVertexCount(); i++) {
		if(objdst.getVertexRefCount(i) > 0) {
			dstvlist.push_back(Point(i, Point::DST));
		}
	}
	// o
	Diff<std::vector<Point> > d(srcvlist, dstvlist);
	d.getDiff(vecdiffmap);
	return TRUE;
}

// _Qvertexesō\ʂ
cmq::findex_t findFacefromVertexes(cmq::CMQObject &obj, const std::vector<cmq::vindex_t> &vertexes)
{
	std::set<cmq::findex_t> target; // e_ɋʂ̖ʂ邽߂̐ϏWi[
	for(cmq::vindex_t v2 : vertexes) {
		std::vector<cmq::findex_t> faces = obj.getVertexRelatedFaces(v2);
		std::set<cmq::findex_t> s; // v2܂ޖʂsetBtargetƂ̐ϏW߂邽
		for(cmq::findex_t findex : faces) {
			s.insert(findex);
		}
		if(target.empty()) {
			target = s;
		}
		else {
			std::set<cmq::findex_t> tmp;
			set_intersection(target.begin(), target.end(), s.begin(), s.end(), inserter(tmp, tmp.begin()));
			if(tmp.empty()) {
				// ʂĂȂ
				target.clear();
				break;
			}
			target = tmp;
		}
	}
	if(target.empty()) {
		// Ώے_͈ʂʂĂȂ
		return -1;
	}
	cmq::findex_t target_findex = *target.begin();
	if(obj.getFacePointCount(target_findex) != vertexes.size()) {
		// ʂ̒_قȂ
		return -1;
	}
	return target_findex;
}

std::pair<cmq::findex_t, int> findSourceFace(cmq::CMQObject&objdst, cmq::CMQObject &objsrc, int findex, const std::unordered_map<cmq::vindex_t, cmq::vindex_t> &vindex_map)
{
	cmq::vindex_t findexsrc = -1;
	int baseindex = 0;

	//  objdst̍\_
	auto dstvarray = objdst.getFacePointArray(findex);
	std::vector<cmq::vindex_t> srcvarray(dstvarray.size());
	// objsrcőΉ_ʂT
	bool fail = false;
	auto it = std::transform(dstvarray.begin(), dstvarray.end(), srcvarray.begin(), [&vindex_map, &fail](cmq::vindex_t vindex) -> cmq::vindex_t {
		auto findit = vindex_map.find(vindex);
		if(findit == vindex_map.end()) {
			// Ή_Ȃ
			fail = true;
			return -1;
		}
		return findit->second;
	});

	if(!fail) {
		// _\ʂ
		findexsrc = findFacefromVertexes(objsrc, srcvarray);
		if(findexsrc >= 0) {
			// varraŷ߂
			std::vector<cmq::vindex_t> varray = objsrc.getFacePointArray(findexsrc);
			auto findit = std::find(varray.begin(), varray.end(), srcvarray.front());
			if(findit != varray.end()) {
				baseindex = findit - varray.begin();
			}
		}
	}
	return std::make_pair(findexsrc, baseindex);
}

/*
	objdstpɍ쐬e[tɁAobjsrc̊e[t̕ό`x𔽉f
*/
BOOL TransMorph::transMorph()
{
	std::unordered_map<int, int> addvertexgrp; // ǉ_ԍǉ_O[vԍ
	int addvertexgrpnumber = 0;
	std::unordered_map<int, std::set<int> > neighborvertex; // ǉ_O[vאڊ_ԍZbg
	std::unordered_map<cmq::vindex_t, cmq::vindex_t> vindex_map; // destsrc_Ή}bv

	for(int vindex = 0; vindex < objdst.getVertexCount(); vindex++) {
		if(objdst.getVertexRefCount(vindex) == 0) {
			// L_łȂ
			continue;
		}
		if(transMorphSetting.selected_vertex_only && !doc.isSelectVertex(objdst, vindex)) {
			// I𒸓_݂̂̏ꍇAI𒸓_ȊO̓XLbv
			continue;
		}
		// Ήsrc_
		int vindexsrc = getSrcVertexFromDstVertex(vindex);
		std::set<int> *pcircumvertex = nullptr;
		MQPoint possrc(0, 0, 0);
		// src̃[t(_ʒu)擾
		if(vindexsrc == -1) {
			// ǉ_
			if(!transMorphSetting.morph_additional_vertex) {
				continue;
			}
			// Ӓ_QT
			auto itneighborgrp = getPeriphery(vindex, addvertexgrp, neighborvertex, addvertexgrpnumber);
			pcircumvertex = &itneighborgrp->second;
		}
		else {
			possrc = objsrc.getVertex(vindexsrc);
		}
		// objsrcƊe[tIuWFNg̒_ʒuAobjdstp̊e[tIuWFNgɑ
		auto itsrc = vecobjmorph.begin(); // fO[tIuWFNg̃Ce[^
		auto itdst = vecobjnewmorph.begin(); // fヂ[tIuWFNg̃Ce[^
		for(; itsrc != vecobjmorph.end(); itsrc++, itdst++) {
			if(transMorphSetting.copy_point) {
				// _[t]
				MQPoint morphing = (vindexsrc == -1) ?
					IDW(vindex, *pcircumvertex, *itsrc) : itsrc->getVertex(vindexsrc) - possrc;
				if(transMorphSetting.morph_mirroring) {
					morphing.x = -morphing.x; // ~[̂XW]
				}
				MQPoint posdst = itdst->getVertex(vindex);
				posdst += morphing * transMorphSetting.rate;
				itdst->setVertex(vindex, posdst);
			}
			if(transMorphSetting.copy_weight && vindexsrc != -1) {
				// EFCg]
				float weight = itsrc->getVertexWeight(vindexsrc);
				itdst->setVertexWeight(vindex, weight);
			}
			if(transMorphSetting.copy_material || transMorphSetting.copy_uv) {
				// ʑ]ʂ̂߂ɁA_ΉmapɋL^Ă
				vindex_map.insert(std::make_pair(vindex, vindexsrc));
			}
		}
	}
	if(transMorphSetting.copy_material || transMorphSetting.copy_uv) {
		// ʑ]
		for(int findex = 0; findex < objdst.getFaceCount(); findex++) {
			if(objdst.getFacePointCount(findex) == 0) {
				// LʂłȂ
				continue;
			}
			if(transMorphSetting.selected_vertex_only && !doc.isSelectFace(objdst, findex)) {
				// uI𒸓_̂݁vw̏ꍇAIʈȊO̓XLbv
				continue;
			}
			auto itsrc = vecobjmorph.begin(); // fO[tIuWFNg̃Ce[^
			auto itdst = vecobjnewmorph.begin(); // fヂ[tIuWFNg̃Ce[^
			for(; itsrc != vecobjmorph.end(); itsrc++, itdst++) {
				UINT ufindex = itdst->getFaceUniqueID(findex);
				cmq::findex_t findexsrc = -1;
				if(!transMorphSetting.morph_mirroring) {
					// j[NIDŖʂ̑ΉBE]łȂƂ
					findexsrc = itsrc->getFaceIndexFromUniqueID(ufindex);
				}
				int arrayindexmodify = 0;
				if(findexsrc == -1) {
					// uniqueIDŌȂʂ̏ꍇ́A̒_\ʂT
					auto findpair = findSourceFace(*itdst, *itsrc, findex, vindex_map);
					if(findpair.first == -1) {
						// ͂茩ȂȂ߂
						findfaceerrorflag = true;
						continue;
					}
					findexsrc = findpair.first; // index
					arrayindexmodify = findpair.second; // ʂ\钸_z̃x[X
				}
				if(transMorphSetting.copy_material) {
					// ގ]
					cmq::mindex_t mat = itsrc->getFaceMaterial(findexsrc);
					itdst->setFaceMaterial(findex, mat);
				}
				if(transMorphSetting.copy_uv) {
					// UV]
					auto carray = itsrc->getFaceCoordinateArray(findexsrc);
					if(transMorphSetting.morph_mirroring) {
						// E]
						int arrayindexmodify_reverse = (arrayindexmodify + 1) % carray.size();
						if(arrayindexmodify_reverse > 0) {
							std::rotate(carray.begin(), carray.begin() + arrayindexmodify_reverse, carray.end());
						}
						std::reverse(carray.begin(), carray.end());
					}
					else {
						// E]Ȃ
						if(arrayindexmodify > 0) {
							std::rotate(carray.begin(), carray.begin() + arrayindexmodify, carray.end());
						}
					}
					itdst->setFaceCoordinateArray(findex, carray);
				}
				if(transMorphSetting.copy_edge) {
					int srcfacecount = itsrc->getFacePointCount(findexsrc);
					// GbWsx
					if(transMorphSetting.morph_mirroring) {
						// E]
						for(int i = srcfacecount - 1; i >= 0; i--) {
							float edge = itsrc->getFaceEdgeCrease(findexsrc, i);
							int to_i = STEPIDX(i - 1, arrayindexmodify, srcfacecount);
							itdst->setFaceEdgeCrease(findex, to_i, edge);
						}
					}
					else {
						// E]Ȃ
						for(int i = 0; i < srcfacecount; i++) {
							float edge = itsrc->getFaceEdgeCrease(findexsrc, i);
							int to_i = STEPIDX(i, arrayindexmodify, srcfacecount);
							itdst->setFaceEdgeCrease(findex, to_i, edge);
						}
					}
				}

			}

		}
	}
	return TRUE;
}

/*
	Inverse Distance Weighting
	idw(x)=sum(u(i)w(i))/sum(w(j))
	w(k)=1/pow(d(k),p)
*/
MQPoint TransMorph::IDW(int vindex, std::set<int> &circumvertex, cmq::CMQObject &morphobj)
{
	MQPoint sum(0, 0, 0);
	MQPoint v = objdst.getVertex(vindex);
	MQPoint u(0, 0, 0);
	float d = 0.0f;
	for(int vcindex : circumvertex) {
		MQPoint vc = objdst.getVertex(vcindex);
		if(v == vc) {
			// ߖTł͂Ȃn_̒_ꍇ͂̃[tl̂̂gp
			int vindexsrc = getSrcVertexFromDstVertex(vcindex);
			MQPoint m = morphobj.getVertex(vindexsrc) - objsrc.getVertex(vindexsrc);
			return m;
		}
		float w = 1.0f / (v - vc).norm(); // p = 2.0
		d += w;
		// morph
		int vindexsrc = getSrcVertexFromDstVertex(vcindex);
		MQPoint m = morphobj.getVertex(vindexsrc) - objsrc.getVertex(vindexsrc);
		u += m * w;
	}
	return d == 0.0f ? u : u / d;
}

// ǉ_̎͒_擾
std::unordered_map<int, std::set<int> >::iterator TransMorph::getPeriphery(int vindex, std::unordered_map<int, int> &addvertexgrp, std::unordered_map<int, std::set<int> > &neighborvertex, int &addvertexgrpnumber)
{
	// ̒_Tς݂
	auto it = addvertexgrp.find(vindex);
	if (it != addvertexgrp.end()) {
		// Tς݂̗אڊ_QԂ
		return neighborvertex.find(it->second);
	}
	// Vǉ_Q
	++addvertexgrpnumber;
	auto added = neighborvertex.insert(make_pair(addvertexgrpnumber, std::set<int>()));
	std::set<int> &circumvertex = added.first->second;
	explorer(vindex, addvertexgrp, circumvertex, addvertexgrpnumber);
	return added.first;
}

void TransMorph::explorer(int vindex, std::unordered_map<int, int> &addvertexgrp, std::set<int> &circumvertex, int addvertexgrpnumber)
{
	// אڒ_擾
	std::set<int> adjacent;
	getAdjacent(vindex, adjacent);
	for(int vadj : adjacent) {
		// _
		if(getSrcVertexFromDstVertex(vadj) != -1) {
			// _
			circumvertex.insert(vadj);
		}
		else if (addvertexgrp.find(vadj) != addvertexgrp.end()) {
			// Tς݂
		}
		else {
			// VKɌSǉ_
			addvertexgrp.insert(make_pair(vadj, addvertexgrpnumber));
			// ċNĂяo
			explorer(vadj, addvertexgrp, circumvertex, addvertexgrpnumber);
		}
	}
}

// אڒ_擾
int TransMorph::getAdjacent(int vindex, std::set<int> &adjacent)
{
	std::vector<int> faces = objdst.getVertexRelatedFaces(vindex);
	for(int findex : faces) {
		std::vector<int> vertexes = objdst.getFacePointArray(findex);
		int vcount = vertexes.size();
		if(vcount == 2) {
			adjacent.insert(vertexes[0] == vindex ? vertexes[1] : vertexes[0]);
		}
		else {
			for(int j = 0; j < vcount; j++) {
				if(vertexes[j] == vindex) {
					adjacent.insert(vertexes[(j + 1) % vcount]);
					adjacent.insert(vertexes[(j + vcount - 1) % vcount]);
					break;
				}
			}
		}
	}
	return adjacent.size();
}


/*
	dst̒_ɑΉsrc̒_ĕԂ
*/
int TransMorph::getSrcVertexFromDstVertex(int vindex)
{
	int vindexsrc = -1;
	// ~[
	if(transMorphSetting.morph_mirroring) {
		auto it = vecmirrormap.find(vindex);
		if(it != vecmirrormap.end()) {
			vindex = it->second;
		}
	}
	if(transMorphSetting.use_unique_id) {
		// UIDQƂsrc_擾
		UINT uid = objdst.getVertexUniqueID(vindex);
		vindexsrc = objsrc.getVertexIndexFromUniqueID(uid);
	}
	else {
		// _Ή}bvQƂsrc_擾
		auto it = vecdiffmap.find(vindex);
		if(it != vecdiffmap.end()) {
			vindexsrc = it->second;
		}
	}
	return vindexsrc;
}

/*
	src擪"#"tgȂOɂAdst̖Osrč̖OŒu
*/
void TransMorph::changeSrcName()
{
	if(!transMorphSetting.keep_basename && objsrc != objdst) {
		string backupname = doc.getUnusedName("#" + transMorphSetting.srcname);
		objsrc.setName(backupname);
		objdst.setName(transMorphSetting.srcname);
	}
}

/*
	obNAbv폜
*/
void TransMorph::deleteBackupObj()
{
	if(!transMorphSetting.backup) {
		auto itsrc = vecobjmorph.begin(); // fO[tIuWFNg̃Ce[^
		for(; itsrc != vecobjmorph.end(); itsrc++) {
			doc.deleteObject(*itsrc);
		}
	}
}

#if MQPLUGIN_VERSION >= 0x0400
BOOL TransMorph::callDialog()
{
	MQWindow mainwin = MQWindow::GetMainWindow();
	TransMorphDialog dlg(mainwin, this, transMorphSetting);
	if(dlg.Execute() != MQDialog::DIALOG_OK){
		return FALSE;
	}
	char **p = nullptr;
	double rate = strtod(cmq::tostring(dlg.edit_rate->GetText()).c_str(), p);
	transMorphSetting.rate = (float)(rate/100.0);

	int count = dlg.list->GetItemCount();
	for(int i = 0; i < count; i++) {
		transMorphSetting.morphlist[i].second = dlg.list->GetItemSelected(i);
	}
	transMorphSetting.keep_basename = dlg.check_keep->GetChecked();
	transMorphSetting.use_unique_id = dlg.check_useuniq->GetChecked();
	transMorphSetting.selected_vertex_only = dlg.check_selvert->GetChecked();
	transMorphSetting.morph_additional_vertex = dlg.check_calcadd->GetChecked();
	transMorphSetting.morph_mirroring = dlg.check_mirror->GetChecked();
	transMorphSetting.backup = dlg.check_backup->GetChecked();
	transMorphSetting.newname = dlg.check_newname->GetChecked();
	transMorphSetting.copy_point = dlg.check_point->GetChecked();
	transMorphSetting.copy_weight = dlg.check_weight->GetChecked();
	transMorphSetting.copy_uv = dlg.check_uv->GetChecked();
	transMorphSetting.copy_material = dlg.check_material->GetChecked();
	transMorphSetting.copy_edge = dlg.check_edge->GetChecked();

	transMorphSetting.going = true;
	return TRUE;
}

TransMorphDialog::TransMorphDialog(MQWindowBase& parent, TransMorph *pPlugin, TransMorph::TransMorphSetting &transMorphSetting) : MQDialog(parent), m_pPlugin(pPlugin)
{
	setlocale(LC_CTYPE, "");
	wchar_t buffer[256] = L"TransMorph";
//	LoadStringW(hInstance, IDS_TITLE, buffer, _countof(buffer));
	SetTitle(buffer);
	SetCanResize(true);
	MQFrame *mainFrame = CreateVerticalFrame(this);
	mainFrame->SetVertLayout(LAYOUT_FILL);

	MQFrame *flameL1 = CreateHorizontalFrame(mainFrame);
	MQFrame *flameL2 = CreateHorizontalFrame(mainFrame);
	flameL2->SetVertLayout(LAYOUT_FILL);
	flameL2->SetHorzLayout(LAYOUT_FILL);

	MQFrame *flameL1B1 = CreateHorizontalFrame(flameL1);
	flameL1B1->SetHorzLayout(LAYOUT_FILL);
	flameL1B1->SetMatrixColumn(2);
	MQFrame *flameL1B2 = CreateVerticalFrame(flameL1);
	flameL1B2->SetFillRateX(30);
	MQFrame *flameL1B3 = CreateVerticalFrame(flameL1);
	flameL1B3->SetFillRateX(10);

	// source, destination
	MQLabel *label_source = CreateLabel(flameL1B1, L"Source");
	label_source->SetFillRateX(30.0);
	MQEdit *edit_source = CreateEdit(flameL1B1);
	edit_source->SetReadOnly(true);
	edit_source->SetText(cmq::towstring(transMorphSetting.srcname));
	edit_source->SetHorzLayout(LAYOUT_FILL);
	edit_source->SetFillRateX(70.0);

	MQLabel *label_destination = CreateLabel(flameL1B1, L"Destination");
	label_destination->SetFillRateX(30.0);
	MQEdit *edit_destination = CreateEdit(flameL1B1);
	edit_destination->SetReadOnly(true);
	edit_destination->SetText(cmq::towstring(transMorphSetting.dstname));
	edit_destination->SetHorzLayout(LAYOUT_FILL);
	edit_destination->SetFillRateX(70.0);

	// Rate
	MQFrame *flameL1B2L1 = CreateHorizontalFrame(flameL1B2);
	MQLabel *label_rate = CreateLabel(flameL1B2L1, L"Rate(&R)");
	edit_rate = CreateEdit(flameL1B2L1);
	edit_rate->SetNumeric(MQEdit::NUMERIC_DOUBLE);
	edit_rate->SetText(L"100");

	// OK,Cancel
	MQButton *button_ok = CreateButton(flameL1B3);
	button_ok->SetText(L"OK");
	button_ok->SetDefault(true);
	button_ok->SetModalResult(DIALOG_OK);
	MQButton *button_cancel = CreateButton(flameL1B3);
	button_cancel->SetText(L"Cancel");
	button_cancel->SetCancel(true);
	button_cancel->SetModalResult(DIALOG_CANCEL);

	MQFrame *flameL2B1 = CreateVerticalFrame(flameL2);
	MQFrame *flameL2B2 = CreateVerticalFrame(flameL2);
	flameL2B1->SetHorzLayout(LAYOUT_FILL);

	// List
	MQFrame *flameL2B1L1 = CreateHorizontalFrame(flameL2B1);
	MQButton *button_all = CreateButton(flameL2B1L1);
	button_all->SetText(L"SđI(&Z)");
	button_all->AddClickEvent(this, &TransMorphDialog::clickAll);
	MQButton *button_invert = CreateButton(flameL2B1L1);
	button_invert->SetText(L"I𔽓](&C)");
	button_invert->AddClickEvent(this, &TransMorphDialog::clickInvert);
	list = CreateListBox(flameL2B1);
	list->SetVertLayout(LAYOUT_FILL);
	list->SetMultiSelect(true);
	listup();
	// options
	check_keep = CreateCheckBox(flameL2B2, L"Source/DestinationIuWFNg̖Oێ(&Q)");
	check_useuniq = CreateCheckBox(flameL2B2, L"꒸_Ƀj[NIDgp(&G)");
	check_useuniq->SetChecked(true);
	check_selvert = CreateCheckBox(flameL2B2, L"I𒸓_̂݃[tf(&S)");
	check_calcadd = CreateCheckBox(flameL2B2, L"ǉ_ɂӒ_vZă[tf(&A)");
	check_calcadd->SetChecked(true);
	check_mirror = CreateCheckBox(flameL2B2, L"[tE](&T)");
	check_backup = CreateCheckBox(flameL2B2, L"obNAbvGg쐬(&X)");
	check_backup->SetChecked(true);
	check_newname = CreateCheckBox(flameL2B2, L"VKGg͕ʖ(`new)ō쐬(&N)");
	check_listonlyelem = CreateCheckBox(flameL2B2, L"GgIuWFNĝ݃XgAbv(&E)");
	check_listonlyelem->AddChangedEvent(this, &TransMorphDialog::checkOnlyElem);
	check_listonlyelem->SetChecked(true);
	check_listsamesize = CreateCheckBox(flameL2B2, L"_̓IuWFNĝ݃XgAbv(&V)");
	check_listsamesize->AddChangedEvent(this, &TransMorphDialog::checkSameSize);
	check_listsamesize->SetChecked(true);
	{
		MQFrame *flameL2B2B = CreateHorizontalFrame(flameL2B2);
		check_point = CreateCheckBox(flameL2B2B, L"W");
		check_point->SetChecked(true);
		check_weight = CreateCheckBox(flameL2B2B, L"EFCg");
		check_weight->SetChecked(true);
		check_edge = CreateCheckBox(flameL2B2B, L"GbW");
		check_edge->SetChecked(true);
		check_material = CreateCheckBox(flameL2B2B, L"ގ");
		check_material->SetChecked(true);
		check_uv = CreateCheckBox(flameL2B2B, L"UV");
		check_uv->SetChecked(true);
	}

	AddKeyDownEvent(this, &TransMorphDialog::keyevent);
}

void TransMorphDialog::listup()
{
	list->ClearItems();
	for(std::pair<cmq::CMQObject, bool> &p : m_pPlugin->transMorphSetting.morphlist) {
		string objname = p.first.getName();
		wstring name = cmq::towstring(objname.c_str());
		int i = list->AddItem(name);
		list->SetItemSelected(i, p.second ? TRUE : FALSE);
	}
	list->MakeItemVisible(0);
}

BOOL TransMorphDialog::clickAll(MQWidgetBase *sender, MQDocument doc)
{
	list->SetEnabled(false);
	int count = list->GetItemCount();
	for(int i = 0; i < count; i++) {
		list->SetItemSelected(i, true);
	}
	list->SetEnabled(true);
	return FALSE;
}

BOOL TransMorphDialog::clickInvert(MQWidgetBase *sender, MQDocument doc)
{
	list->SetEnabled(false);
	int count = list->GetItemCount();
	for(int i = 0; i < count; i++) {
		list->SetItemSelected(i, !list->GetItemSelected(i));
	}
	list->SetEnabled(true);
	return FALSE;
}

BOOL TransMorphDialog::checkOnlyElem(MQWidgetBase *sender, MQDocument doc)
{
	m_pPlugin->getMorphObjects(check_listonlyelem->GetChecked(), check_listsamesize->GetChecked());
	listup();
	return FALSE;
}

BOOL TransMorphDialog::checkSameSize(MQWidgetBase *sender, MQDocument doc)
{
	m_pPlugin->getMorphObjects(check_listonlyelem->GetChecked(), check_listsamesize->GetChecked());
	listup();
	return FALSE;
}

BOOL TransMorphDialog::checkKeep(MQWidgetBase *sender, MQDocument doc) {check_keep->SetChecked(!check_keep->GetChecked()); return FALSE;}
BOOL TransMorphDialog::checkUseUnique(MQWidgetBase *sender, MQDocument doc) {check_useuniq->SetChecked(!check_useuniq->GetChecked()); return FALSE;}
BOOL TransMorphDialog::checkSelVert(MQWidgetBase *sender, MQDocument doc) {check_selvert->SetChecked(!check_selvert->GetChecked()); return FALSE;}
BOOL TransMorphDialog::checkCalcAdd(MQWidgetBase *sender, MQDocument doc) {check_calcadd->SetChecked(!check_calcadd->GetChecked()); return FALSE;}
BOOL TransMorphDialog::checkMirror(MQWidgetBase *sender, MQDocument doc) {check_mirror->SetChecked(!check_mirror->GetChecked()); return FALSE;}
BOOL TransMorphDialog::checkBackup(MQWidgetBase *sender, MQDocument doc) {check_backup->SetChecked(!check_backup->GetChecked()); return FALSE;}
BOOL TransMorphDialog::checkNewName(MQWidgetBase *sender, MQDocument doc) {check_newname->SetChecked(!check_newname->GetChecked()); return FALSE;}
BOOL TransMorphDialog::checkListOnlyElem(MQWidgetBase *sender, MQDocument doc) {
	check_listonlyelem->SetChecked(!check_listonlyelem->GetChecked());
	return checkOnlyElem(sender, doc);
}
BOOL TransMorphDialog::checkListSameSaze(MQWidgetBase *sender, MQDocument doc) {
	check_listsamesize->SetChecked(!check_listsamesize->GetChecked());
	return checkSameSize(sender, doc);
}

BOOL TransMorphDialog::keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam& param)
{
	if(param.Alt) {
		switch(param.Key) {
		case 0x5A: clickAll(sender, doc); break;
		case 0x43: clickInvert(sender, doc); break;
		case 0x51: checkKeep(sender, doc); break;
		case 0x47: checkUseUnique(sender, doc); break;
		case 0x53: checkSelVert(sender, doc); break;
		case 0x41: checkCalcAdd(sender, doc); break;
		case 0x54: checkMirror(sender, doc); break;
		case 0x58: checkBackup(sender, doc); break;
		case 0x4E: checkNewName(sender, doc); break;
		case 0x45: checkListOnlyElem(sender, doc); break;
		case 0x56: checkListSameSaze(sender, doc); break;
		case 0x34: edit_rate->SetFocus(true); break;
		}
	}
	return FALSE;
}

#else
BOOL TransMorph::callDialog()
{
	transMorphSetting.pPlugin = this;
	DialogBox(hInstance, MAKEINTRESOURCE(DLG_TRANSMORPH), MQ_GetWindowHandle(), &TransMorph::TransMorphDialogProc);
	return TRUE;
}
/*
	ݒ_CAOpR[obN֐
*/
BOOL CALLBACK TransMorph::TransMorphDialogProc(
	HWND hwndDlg, // handle to dialog box
	UINT uMsg, // message
	WPARAM wParam, // first message parameter
	LPARAM lParam // second message parameter
	)
{
	switch(uMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDOK:
			// src/dstIuWFNg̖Oێ
			transMorphSetting.keep_basename = (IsDlgButtonChecked(hwndDlg, IDC_KEEPOBJNAME) == BST_CHECKED);
			// ꒸_Ƀj[NIDgp
			transMorphSetting.use_unique_id = (IsDlgButtonChecked(hwndDlg, IDC_USEUNIQID) == BST_CHECKED);
			// I𒸓_̂݃[tf
			transMorphSetting.selected_vertex_only = (IsDlgButtonChecked(hwndDlg, IDC_SELVERT) == BST_CHECKED);
			// ǉ_Ƀ[tf
			transMorphSetting.morph_additional_vertex = (IsDlgButtonChecked(hwndDlg, IDC_CALCADDITIONAL) == BST_CHECKED);
			// [tE]
			transMorphSetting.morph_mirroring = (IsDlgButtonChecked(hwndDlg, IDC_MORPHMIRROR) == BST_CHECKED);
			// obNAbvȂ
			transMorphSetting.backup = (IsDlgButtonChecked(hwndDlg, IDC_BACKUP) == BST_CHECKED);
			// VK[t͕ʖō쐬
			transMorphSetting.newname = (IsDlgButtonChecked(hwndDlg, IDC_NEWNAME) == BST_CHECKED);
			// elem̍WRs[
			transMorphSetting.copy_point = (IsDlgButtonChecked(hwndDlg, IDC_COPYPOINT) == BST_CHECKED);
			// elem̃EFCgRs[
			transMorphSetting.copy_weight = (IsDlgButtonChecked(hwndDlg, IDC_COPYWEIGHT) == BST_CHECKED);
			// elem̃GbWRs[
			transMorphSetting.copy_edge = (IsDlgButtonChecked(hwndDlg, IDC_COPYEDGE) == BST_CHECKED);
			// elem̍ގRs[
			transMorphSetting.copy_material = (IsDlgButtonChecked(hwndDlg, IDC_COPYMATERIAL) == BST_CHECKED);
			// elemUVRs[
			transMorphSetting.copy_uv = (IsDlgButtonChecked(hwndDlg, IDC_COPYUV) == BST_CHECKED);
			{
				// Xg{bNX̑IԂ擾
				HWND hwndList = GetDlgItem(hwndDlg, IDC_LIST1);
				for(size_t i = 0; i < transMorphSetting.morphlist.size(); i++) {
					LRESULT selected = SendMessage(hwndList, LB_GETSEL, i, 0);
					transMorphSetting.morphlist[i].second = (selected > 0);
				}
			}
			{
				char buffer[10];
				GetDlgItemText(hwndDlg, IDC_RATE, buffer, 10);
				transMorphSetting.rate = atoi(buffer)/100.0; 
			}
			transMorphSetting.going = true;
			EndDialog(hwndDlg, TRUE);
			return TRUE;
		case IDCANCEL:
			PostMessage(hwndDlg, WM_CLOSE, 0, 0);
			return TRUE;
		case IDC_SELALL:
			{
				// SđI
				HWND hwndList = GetDlgItem(hwndDlg, IDC_LIST1);
				for(size_t i = 0; i < transMorphSetting.morphlist.size(); i++) {
					SendMessage(hwndList, LB_SETSEL, TRUE, i);
				}
			}
			return TRUE;
		case IDC_SELINV:
			{
				// I𔽓]
				HWND hwndList = GetDlgItem(hwndDlg, IDC_LIST1);
				for(size_t i = 0; i < transMorphSetting.morphlist.size(); i++) {
					LRESULT selected = SendMessage(hwndList, LB_GETSEL, i, 0);
					SendMessage(hwndList, LB_SETSEL, selected == 0 ? TRUE : FALSE, i);
				}
			}
			return TRUE;
		case IDC_ONLYELEM:
		case IDC_SAMESIZE:
			{
				BOOL checkedOnlyElem = SendMessage(GetDlgItem(hwndDlg, IDC_ONLYELEM), BM_GETCHECK, 0, 0);
				BOOL checkedSameSize = SendMessage(GetDlgItem(hwndDlg, IDC_SAMESIZE), BM_GETCHECK, 0, 0);
				transMorphSetting.pPlugin->getMorphObjects(checkedOnlyElem == TRUE, checkedSameSize == TRUE);
				listup(hwndDlg);
			}
			return TRUE;
		}
		break;

	case WM_INITDIALOG:
		CheckDlgButton(hwndDlg, IDC_KEEPOBJNAME, BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_USEUNIQID, BST_CHECKED);
		CheckDlgButton(hwndDlg, IDC_SELVERT, BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_CALCADDITIONAL, BST_CHECKED);
		CheckDlgButton(hwndDlg, IDC_MORPHMIRROR, BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_BACKUP, BST_CHECKED);
		CheckDlgButton(hwndDlg, IDC_NEWNAME, BST_UNCHECKED);
		CheckDlgButton(hwndDlg, IDC_ONLYELEM, BST_CHECKED);
		CheckDlgButton(hwndDlg, IDC_SAMESIZE, BST_CHECKED);
		CheckDlgButton(hwndDlg, IDC_COPYPOINT, BST_CHECKED);
		CheckDlgButton(hwndDlg, IDC_COPYWEIGHT, BST_CHECKED);
		CheckDlgButton(hwndDlg, IDC_COPYEDGE, BST_CHECKED);
		CheckDlgButton(hwndDlg, IDC_COPYMATERIAL, BST_CHECKED);
		CheckDlgButton(hwndDlg, IDC_COPYUV, BST_CHECKED);
		{
			SetDlgItemText(hwndDlg, IDC_SRCOBJ, transMorphSetting.srcname.c_str());
			SetDlgItemText(hwndDlg, IDC_DSTOBJ, transMorphSetting.dstname.c_str());
			listup(hwndDlg);
		}
		{
			SetDlgItemText(hwndDlg, IDC_RATE, "100") ;
		}
		return TRUE;

	case WM_CLOSE:
		EndDialog(hwndDlg, FALSE);
		return TRUE;
		break;
	}

	return FALSE;
}

void TransMorph::listup(HWND hwndDlg)
{
	HWND hwndList = GetDlgItem(hwndDlg, IDC_LIST1);
	SendMessage(hwndList, LB_RESETCONTENT, 0, 0);
	for(std::pair<cmq::CMQObject, bool> &p : transMorphSetting.morphlist) {
		string objname = p.first.getName();
		int pos = (int)SendMessage(hwndList, LB_ADDSTRING, 0, (LPARAM)objname.c_str()); 
		SendMessage(hwndList, LB_SETSEL, p.second ? TRUE : FALSE, pos);
	}
	SendMessage(hwndList, LB_SETCARETINDEX , 0, FALSE);
}

#endif

